//Load add-ons into separate add-ons gui

function loadHubAddons()
{
	if(isObject(HAOG_Scroll.getObject(0)))
	{
		HAOG_Scroll.getObject(0).delete();
	}
	%addonSwatch = new GuiSwatchCtrl()
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "256 1";
		minExtent = "8 2";
		visible = "1";
		color = "0 0 0 0";
	};
	HAOG_Scroll.add(%addonSwatch);
	%file = new fileObject();
	%file.openForRead("Config/Server/ADD_ON_LIST.cs");
	%Pos = "5 -19";
	%Add = "0 18";
	while(!%file.isEOF())
	{
		%AddonVariable = %file.readLine();
		%Addon = getSubStr(%AddonVariable,8,strLen(%AddonVariable) - 8);
		%Addon = getSubStr(%Addon,0,strPos(%Addon," ="));
		%AddonCategory = getSubStr(%Addon,0,strPos(%Addon,"_"));
		if(!%Category[%AddonCategory])
		{
			%swatch = new GuiSwatchCtrl()
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = %Pos = getWords(vectorAdd(%Pos,"0 22"),0,1);
				extent = "13 13";
				minExtent = "8 2";
				visible = 1;
				color = "0 0 0 255";
			};
			HAOG_Scroll.getObject(0).add(%swatch);

			%category = new GuiCheckBoxCtrl()
			{
				profile = "GuiCheckBoxBoldProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = getWords(vectorAdd(%Pos,"0 -2"),0,1);
				extent = "256 18";
				minExtent = "8 2";
				visible = 1;
				text = %AddonCategory;
				groupNum = "-1";
				buttonType = "ToggleButton";
				category = %AddonCategory;
			};
			%category.command = "HAOG_tickCategory("@%category@");";
			%category.numChildren = 0;
			HAOG_Scroll.getObject(0).add(%category);

			%break = new GuiSwatchCtrl()
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = %Pos = getWords(vectorAdd(%Pos,%Add),0,1);
				extent = "256 2";
				minExtent = "8 2";
				visible = 1;
				color = "0 0 0 255";
			};
			HAOG_Scroll.getObject(0).add(%break);
			%Add = "0 5";
			%Category[%AddonCategory] = 1;
		}

		%newAddon = new GuiCheckBoxCtrl()
		{
			profile = "GuiCheckBoxProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = %Pos = getWords(vectorAdd(%Pos,%Add),0,1);
			extent = "256 18";
			minExtent = "8 2";
			visible = 1;
			text = %Addon;
			groupNum = "-1";
			buttonType = "ToggleButton";
			Parent = %category;
			varName = %Addon;
		};
		HAOG_Scroll.getObject(0).add(%newAddon);
		%newAddon.command = "HAOG_tickAddon("@%newAddon@");";
		%category.child[%category.numChildren] = %newAddon;
		%category.numChildren++;
		%Add = "0 18";
	}
	%file.close();
	%file.delete();

	for(%i=0;%i < HAOG_Scroll.getObject(0).getCount();%i++)
	{
		%list = HAOG_Scroll.getObject(0).getObject(%i);
		if(isObject(%list.Parent))
		{
			%name = %list.varName;
			if($HubAddon::addon[%name])
			{
				%list.setValue(1);
				HAOG_tickAddon(%list);
			}
			else
			{
				$HubAddon::addon[%name] = 0;
			}
		}
	}
	HAOG_Scroll.getObject(0).extent = "256" SPC getWord(%newAddon.position,1) + 18;
}
function HAOG_tickCategory(%Category)
{
	if(!%Category.getValue())
	{
		for(%i=0;%i<%Category.numChildren;%i++)
		{
			if(%Category.child[%i].getValue())
			{
				%Category.numEnabled--;
			}
			%Category.child[%i].setValue(0);
			$HubAddon::addon[%Category.child[%i].varName] = 0;
		}
	}
	else
	{
		for(%i=0;%i<%Category.numChildren;%i++)
		{
			if(!%Category.child[%i].getValue())
			{
				%Category.numEnabled++;
			}
			%Category.child[%i].setValue(1);
			$HubAddon::addon[%Category.child[%i].varName] = 1;
		}
	}
}
function HAOG_tickAddon(%add)
{
	if(%add.getValue())
	{
		%add.Parent.numEnabled++;
		$HubAddon::addon[%add.varName] = 1;
		if(%add.Parent.numEnabled >= %add.Parent.numChildren)
		{
			%add.Parent.setValue(1);
		}
	}
	else
	{
		%add.Parent.numEnabled--;
		$HubAddon::addon[%add.varName] = 0;
		if(%add.Parent.getValue())
		{
			%add.Parent.setValue(0);
		}
	}
}
function HAOG_clickNone()
{
	for(%i=0;%i < HAOG_Scroll.getObject(0).getCount();%i++)
	{
		%list = HAOG_Scroll.getObject(0).getObject(%i);
		if(isObject(%list.child0))
		{
			%list.setValue(0);
			HAOG_tickCategory(%list);
		}
	}
}
function HAOG_clickAll()
{
	for(%i=0;%i < HAOG_Scroll.getObject(0).getCount();%i++)
	{
		%list = HAOG_Scroll.getObject(0).getObject(%i);
		if(isObject(%list.child0))
		{
			%list.setValue(1);
			HAOG_tickCategory(%list);
		}
	}
}
function HAOG_clickDefault()
{
	for(%i=0;%i < HAOG_Scroll.getObject(0).getCount();%i++)
	{
		%list = HAOG_Scroll.getObject(0).getObject(%i);
		if(isObject(%list.Parent))
		{
			%name = %list.varName;
			switch$(%name)
			{
				case "Brick_Arch":  %list.setValue(0); %list.performClick();
				case "Brick_Large_Cubes":  %list.setValue(0); %list.performClick();
				case "Emote_Alarm":  %list.setValue(0); %list.performClick();
				case "Emote_Confusion":  %list.setValue(0); %list.performClick();
				case "Emote_Love":  %list.setValue(0); %list.performClick();
				case "Emote_Hate":  %list.setValue(0); %list.performClick();
				case "Item_Skis":  %list.setValue(0); %list.performClick();
				case "Light_Animated":  %list.setValue(0); %list.performClick();
				case "Light_Basic":  %list.setValue(0); %list.performClick();
				case "Particle_Basic":  %list.setValue(0); %list.performClick();
				case "Particle_FX_Cans":  %list.setValue(0); %list.performClick();
				case "Particle_Grass":  %list.setValue(0); %list.performClick();
				case "Particle_Player":  %list.setValue(0); %list.performClick();
				case "Particle_Tools":  %list.setValue(0); %list.performClick();
				case "Player_Fuel_Jet":  %list.setValue(0); %list.performClick();
				case "Player_Jump_Jet":  %list.setValue(0); %list.performClick();
				case "Player_Leap_Jet":  %list.setValue(0); %list.performClick();
				case "Player_No_Jet":  %list.setValue(0); %list.performClick();
				case "Player_Quake":  %list.setValue(0); %list.performClick();
				case "Print_1x2f_BLPRemote":  %list.setValue(0); %list.performClick();
				case "Print_1x2f_Default":  %list.setValue(0); %list.performClick();
				case "Print_2x2f_Default":  %list.setValue(0); %list.performClick();
				case "Print_2x2r_Default":  %list.setValue(0); %list.performClick();
				case "Print_2x2r_Monitor3":  %list.setValue(0); %list.performClick();
				case "Print_Letters_Default":  %list.setValue(0); %list.performClick();
				case "Projectile_GravityRocket":  %list.setValue(0); %list.performClick();
				case "Projectile_Pinball":  %list.setValue(0); %list.performClick();
				case "Projectile_Pong":  %list.setValue(0); %list.performClick();
				case "Projectile_Radio_Wave":  %list.setValue(0); %list.performClick();
				case "Sound_Beeps":  %list.setValue(0); %list.performClick();
				case "Sound_Phone":  %list.setValue(0); %list.performClick();
				case "Sound_Synth4":  %list.setValue(0); %list.performClick();
				case "Vehicle_Ball":  %list.setValue(0); %list.performClick();
				case "Vehicle_Flying_Wheeled_Jeep":  %list.setValue(0); %list.performClick();
				case "Vehicle_Horse":  %list.setValue(0); %list.performClick();
				case "Vehicle_Jeep":  %list.setValue(0); %list.performClick();
				case "Vehicle_Magic_Carpet":  %list.setValue(0); %list.performClick();
				case "Vehicle_Pirate_Cannon":  %list.setValue(0); %list.performClick();
				case "Vehicle_Rowboat":  %list.setValue(0); %list.performClick();
				case "Vehicle_Tank":  %list.setValue(0); %list.performClick();
				case "Weapon_Bow":  %list.setValue(0); %list.performClick();
				case "Weapon_Gun":  %list.setValue(0); %list.performClick();
				case "Weapon_Guns_Akimbo":  %list.setValue(0); %list.performClick();
				case "Weapon_Horse_Ray":  %list.setValue(0); %list.performClick();
				case "Weapon_Push_Broom":  %list.setValue(0); %list.performClick();
				case "Weapon_Rocket_Launcher":  %list.setValue(0); %list.performClick();
				case "Weapon_Spear":  %list.setValue(0); %list.performClick();
				case "Weapon_Sword":  %list.setValue(0); %list.performClick();
			}
		}
	}
}
function HAOG_clickMinimal()
{
	for(%i=0;%i < HAOG_Scroll.getObject(0).getCount();%i++)
	{
		%list = HAOG_Scroll.getObject(0).getObject(%i);
		if(isObject(%list.Parent))
		{
			%name = %list.varName;
			switch$(%name)
			{
				case "Brick_Arch":  %list.setValue(0); %list.performClick();
				case "Brick_Large_Cubes":  %list.setValue(0); %list.performClick();
				case "Light_Animated":  %list.setValue(0); %list.performClick();
				case "Light_Basic":  %list.setValue(0); %list.performClick();
				case "Particle_Basic":  %list.setValue(0); %list.performClick();
				case "Particle_FX_Cans":  %list.setValue(0); %list.performClick();
				case "Particle_Player":  %list.setValue(0); %list.performClick();
				case "Print_1x2f_Default":  %list.setValue(0); %list.performClick();
				case "Print_2x2f_Default":  %list.setValue(0); %list.performClick();
				case "Print_2x2r_Default":  %list.setValue(0); %list.performClick();
				case "Print_Letters_Default":  %list.setValue(0); %list.performClick();
				case "Sound_Beeps":  %list.setValue(0); %list.performClick();
				case "Sound_Phone":  %list.setValue(0); %list.performClick();
				case "Sound_Synth4":  %list.setValue(0); %list.performClick();
			}
		}
	}
}
function convertToHubAddons()
{
	loadHubAddons();

	%file = new fileObject();
	%file.openForRead("Config/Server/ADD_ON_LIST.cs");
	%file2 = new fileObject();
	%file2.openForWrite("Config/Server/BackupAddonList.cs");
	while(!%file.isEOF())
	{
		%line = %file.readLine();
		%file2.writeLine(%line);
	}
	%file.close();
	%file.delete();
	%file2.close();
	%file2.delete();

	%file3 = new fileObject();
	%file3.openForWrite("Config/Server/ADD_ON_LIST.cs");
	for(%i=0;%i < HAOG_Scroll.getObject(0).getCount();%i++)
	{
		%list = HAOG_Scroll.getObject(0).getObject(%i);
		if(isObject(%list.Parent))
		{
			%name = %list.varName;
			%line = "$Addon__"@ %name @" = \""@ $HubAddon::addon[%name] @"\";";
			%file3.writeLine(%line);
		}
	}
	%file3.close();
	%file3.delete();

	exec("Config/Server/ADD_ON_LIST.cs");
}
function restoreOriginalAddons()
{
	if(isFile("Config/Server/BackupAddonList.cs"))
	{
		%file = new fileObject();
		%file.openForRead("Config/Server/BackupAddonList.cs");
		%file2 = new fileObject();
		%file2.openForWrite("Config/Server/ADD_ON_LIST.cs");
		while(!%file.isEOF())
		{
			%line = %file.readLine();
			%file2.writeLine(%line);
		}
		%file.close();
		%file2.close();
		%file.delete();
		%file2.delete();
		fileDelete("Config/Server/BackupAddonList.cs");

		exec("Config/Server/ADD_ON_LIST.cs");
	}
}
function convertToNormalAddons()
{
	for(%i=0;%i < HAOG_Scroll.getObject(0).getCount();%i++)
	{
		%list = HAOG_Scroll.getObject(0).getObject(%i);
		if(isObject(%list.Parent))
		{
			%name = %list.varName;
			if($Addon__[%name])
			{
				%list.setValue(1);
				HAOG_tickAddon(%list);
			}
			else
			{
				%list.setValue(0);
				HAOG_tickAddon(%list);
			}
		}
	}
}