registerOutputEvent("GameConnection", "GoToMainMenu");
registerOutputEvent("GameConnection", "StartServer");
registerOutputEvent("GameConnection", "JoinServer");
registerOutputEvent("GameConnection", "OpenOptions");
registerOutputEvent("GameConnection", "QuitGame");
registerOutputEvent("GameConnection", "OpenModManager");
registerOutputEvent("GameConnection", "OpenIRCClient");

if($Server::ServerType !$= "SinglePlayer")
{
	unregisterOutputEvent("GameConnection", "GoToMainMenu");
	unregisterOutputEvent("GameConnection", "StartServer");
	unregisterOutputEvent("GameConnection", "JoinServer");
	unregisterOutputEvent("GameConnection", "OpenOptions");
	unregisterOutputEvent("GameConnection", "QuitGame");
	unregisterOutputEvent("GameConnection", "OpenModManager");
	unregisterOutputEvent("GameConnection", "OpenIRCClient");
	error("ERROR: Client_Hub/Events.cs: executed outside of single player server");
	return;
}

function GameConnection::GoToMainMenu(%this)
{
	disconnect();
}
function GameConnection::StartServer(%this)
{
	canvas.pushDialog(StartMissionGUI);
}
function GameConnection::JoinServer(%this)
{
	canvas.pushDialog(JoinServerGUI);
}
function GameConnection::OpenOptions(%this)
{
	canvas.pushDialog(OptionsDlg);
}
function GameConnection::QuitGame(%this)
{
	quit();
}
function GameConnection::OpenModManager(%this)
{
	canvas.pushDialog(RTB_ModManager);
}
function GameConnection::OpenIRCClient(%this)
{
	canvas.pushDialog(RTB_IRCClient);
}